#region License
/* ****************************************************************************
 * Copyright (c) Llewellyn Pritchard. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. 
 * A copy of the license can be found in the License.html file at the root of this distribution. 
 * By using this source code in any fashion, you are agreeing to be bound by the terms of the 
 * Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 * ***************************************************************************/
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting.Hosting;
using Microsoft.Scripting;
using Microsoft.Scripting.Actions;
using IronLisp.Actions;
using System.Reflection;
using System.Collections;
using IronLisp.Runtime;
using System.Diagnostics;

namespace IronLisp.Hosting
{
  public class IronLispScriptEngine : ScriptEngine
  {
    public IronLispScriptEngine(LanguageProvider lp, EngineOptions eo, LanguageContext lc)
      : base(lp, eo, lc)
    {
      ((IronLispLanguageContext)LanguageContext).se = this;
    }

    protected override void PrintInteractiveCodeResult(object obj)
    {
      string strv = Builtins.DisplayFormat(obj);
      Console.WriteLine("{0}", strv);
    }

    #region Abstract


    public override ActionBinder DefaultBinder
    {
      get { return new IronLispActionBinder(null); }
    }

    #endregion

    protected override LanguageContext GetLanguageContext(CompilerOptions compilerOptions)
    {
      return LanguageContext;
    }

    #region Virtual

    public override string Copyright
    {
      get
      {
        return "leppie 2007";
      }
    }

    public override string VersionString
    {
      get
      {
        return "0.0.1";
      }
    }

    #endregion

    internal CodeContext CreateContext(ModuleContext mc)
    {
      return new CodeContext(new Scope(), LanguageContext, mc);
    }
  }
}
