using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using IronLisp.Runtime;

namespace Tests
{
  [TestFixture]
  public class ConsTests
  {
    [Test]
    public void Create()
    {
      Cons a = null;
      Cons b = new Cons(1);
      Cons c = new Cons(1, 2);

      Cons d = new Cons(3, c);

      Cons e = new Cons(4, a);
      Cons f = new Cons(4, b);

      Cons g = new Cons(0, new object[] { 1, 2, 3, 4, 5, 6 });

      Cons h = new Cons(d, b);
      Cons i = new Cons(c, h);
    }

    [Test]
    public void Factory()
    {
      Cons a = Cons.FromArray();
      Cons b = Cons.FromArray(1);
      Cons c = Cons.FromArray(1, 2);
      Cons d = Cons.FromArray(1, 2, 3);
      Cons e = Cons.FromArray(1, d);

      Cons f = Cons.FromList(new object[] { 1, 2, 3, 4, 5, 6 });
    }


    [Test]
    public void Reverse()
    {
      Cons f = Cons.FromList(new object[] { 1, 2, 3, 4, 5, 6 });

      Cons g = f.Reverse();
    }
  }
}
