(= sqrt (fn (x)

  (= square (fn (x)
    (* x x)))

  (= abs (fn (x)
    (if (< x 0)
        (- x)
        x)))

  (= average (fn (x y)
    (/ (+ x y) 2)))        

  (= good-enough? (fn (guess)
    (< (abs (- (square guess) x)) 0.001)))

  (= improve  (fn (guess)
    (average guess (/ x guess))))

  (= sqrt-iter (fn (guess)
    (if (good-enough? guess)
        guess
        (sqrt-iter (improve guess)))))

  (sqrt-iter 1.0)))

(prl (sqrt 10000))

