       
(= square (fn (x)
  (* x x)))

(= abs (fn (x)
  (if (< x 0)
      (- x)
      x)))

(= good-enough? (fn (guess x)
  (< (abs (- (square guess) x)) 0.001)))


(= average (fn (x y)
  (/ (+ x y) 2)))


(= improve (fn (guess x)
  (average guess (/ x guess))))


(= sqrt-iter (fn (guess x)
  (if (good-enough? guess x)
      guess
      (sqrt-iter (improve guess x)
                 x))))


(= sqrt (fn (x)
  (sqrt-iter 1.0 x)))
  
  
(prl (sqrt 1333418256)) ;prints 36516 (which is incidentally correct)
