(= defmacro (macro (name args &rest body) 
  `(= ,name (macro ,args ,@body))))  

(defmacro defun (name args &rest body) 
  `(= ,name (fn ,args ,@body)))
  
(defun hello (x)
  (prl x)
  (prl "hello")
  (prl x))  

(hello "leppie")

(defmacro define (name value)
  `(= ,name ,value))
  
(defmacro listp (l) 
  `(or (eq null ,l) (is cons ,l)))

(defun islist (x)
   (listp x))
   
(prl (islist 1))

(define ml '(1 2 3 4))
(prl (listp ml))


  
;;http://www.apl.jhu.edu/~hall/Lisp-Notes/Macros.html
  
(defmacro square (x)
  `(let y ,x
      (* y y)))
      
   
  
(defun foo () 4)  
  
(prl (square 4))    
(prl (square (foo)))  



(defmacro square-sum (x y)
  `(let ((first ,x)
         (second ,y)
         (sum (+ first second)))
     (* sum sum)) )


(prl (square-sum 3 4))

(= first 4)
(prl (square-sum 3 first))

(defmacro square-sum2 (x y)
  (let ((first (gensym))
        (second (gensym "second"))
        (sum (gensym "sum")))
    `(let ((,first ,x)
           (,second ,y)
           (,sum (+ ,first ,second)))
       (* ,sum ,sum))
))

(prl (square-sum2 3 first))

; this handled like a macro
(prl (macroexpand square-sum2 3 first))
(prl (macroexpand defun foo () 4))

; check round trip
(prl (eval (macroexpand square-sum2 3 first)))


; weird tests
(defmacro defun2 (name args body) 
  `(= ,name (fn ,args ,@body)))  
  
(prl (macroexpand '(defun foo () 4)))

((eval (macroexpand '(defun2 foo () ((prl 1)(prl 2))))))

(defun2 foo () (4))
