//
//  This CSharp output file generated by Gardens Point LEX
//  Version:  0.5.1.126 (2007-03-28)
//  Machine:  UBER-VISTA
//  DateTime: 2007/08/18 11:49:15 AM
//  UserName: leppie
//  GPLEX input file <IronLisp.lex>
//  GPLEX frame file <Z:\dev\IronLisp\tools\gplexx.frame>
//
//  Option settings: noverbose, parser, stack, nominimize, compress
//

#define BACKUP
#define STACK
//
// gplexx.frame
// Version 0.5.1 of 11 March 2007
// Derived from gplex.frame version of 2-September-2006. 
// Left and Right Anchored state support.
// Start condition stack. Two generic params.
// Using fixed length context handling for right anchors
//
using System;
using System.IO;
using System.Collections.Generic;
#if !STANDALONE
using gppg;
#endif


namespace IronLisp.Compilers
{   
    /// <summary>
    /// Summary Canonical example of GPLEX automaton
    /// </summary>
    
#if STANDALONE
    //
    // These are the dummy declarations for stand-alone GPLEX applications
    // normally these declarations would come from the parser.
    // If you declare /noparser, or %option noparser then you get this.
    //

    public enum Tokens
    { 
      EOF = 0, maxParseToken = int.MaxValue 
      // must have at least these two, values are almost arbitrary
    }

    public abstract class ScanBase
    {
        public abstract int yylex();
#if BABEL
        protected abstract int CurrentSc { get; set; }
        // EolState is the 32-bit of state data persisted at 
        // the end of each line for Visual Studio colorization.  
        // The default is to return CurrentSc.  You must override
        // this if you want more complicated behavior.
        public virtual int EolState { get { return CurrentSc; set { CurrentSc = value; } }
    }
    
    public interface IColorScan
    {
        void SetSource(string source, int offset);
        int GetNext(ref int state, out int start, out int end);
#endif // BABEL
    }

#endif // STANDALONE

    public abstract class ScanBuff
    {
        public const char EOF = (char)256;
        public abstract int Pos { get; set; }
        public abstract int Read();
        public abstract int Peek();
        public abstract string GetString(int b, int e);
    }
    
    // If the compiler can't find ScanBase maybe you need to run
    // GPPG with the /gplex option, or GPLEX with /noparser
#if BABEL
    public sealed class Scanner : ScanBase, IColorScan
    {
        public ScanBuff buffer;
        int currentScOrd;  // start condition ordinal
        
        protected override int CurrentSc 
        {
             // The current start state is a property
             // to try to avoid the user error of setting
             // scState but forgetting to update the FSA
             // start state "currentStart"
             //
             get { return currentScOrd; }  // i.e. return YY_START;
             set { currentScOrd = value;   // i.e. BEGIN(value);
                   currentStart = startState[value]; }
        }
#else  // BABEL
    public sealed class Scanner : ScanBase
    {
        public ScanBuff buffer;
        int currentScOrd;  // start condition ordinal
#endif // BABEL
        
        private static int GetMaxParseToken() {
            System.Reflection.FieldInfo f = typeof(Tokens).GetField("maxParseToken");
            return (f == null ? int.MaxValue : (int)f.GetValue(null));
        }
        
        static int parserMax = GetMaxParseToken();
        
        enum Result {accept, noMatch, contextFound};

        const int maxAccept = 204;
        const int initial = 205;
        const int eofNum = 0;
        const int goStart = -1;
        const int INITIAL = 0;
        const int ML_COMMENT = 1;

/* ****************************************************************************
 * Copyright (c) Llewellyn Pritchard. 
 *
 * This source code is subject to terms and conditions of the Microsoft Permissive License. 
 * A copy of the license can be found in the License.html file at the root of this distribution. 
 * By using this source code in any fashion, you are agreeing to be bound by the terms of the 
 * Microsoft Permissive License.
 *
 * You must not remove this notice, or any other, from this software.
 * ***************************************************************************/
public override void yyerror(string format, params object[] args)
{
  if (!format.Contains("EOF"))
  {
    Console.Error.WriteLine(format, args);
  }
}

public int Make(Tokens token)
{
  yylval.text = yytext;
  yylloc = new LexLocation(tokLin,tokCol,tokELin,tokECol);
  return (int)token;
}
        int state;
        int currentStart = initial;
        int chr;           // last character read
        int cPos;          // position of chr
        int lNum = 0;      // current line number
        int lineStart;     // start of line

        //
        // The following instance variables are used, among other
        // things, for constructing the yylloc location objects.
        //
        int tokPos;        // buffer position at start of token
        int tokCol;        // zero-based column number at start of token
        int tokLin;        // line number at start of token
        int tokEPos;       // buffer position at end of token
        int tokECol;       // column number at end of token
        int tokELin;       // line number at end of token
        string tokTxt;     // lazily constructed text of token
#if STACK          
        private Stack<int> scStack = new Stack<int>();
#endif // STACK

#region ScannerTables
   struct Table {
        public int min; public int rng; public int dflt;
        public short[] nxt;
        public Table(int m, int x, int d, short[] n) {
            min = m; rng = x; dflt = d; nxt = n;
        }
    };

   static int[] startState = {205, 230, 0};

    static Table[] NxS = new Table[231];

    static Scanner() {
    NxS[0] = new Table(0, 0, 0, null);
    NxS[1] = new Table(0, 0, -1, null);
    NxS[2] = new Table(9, 24, -1, new short[] {200, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, 200});
    NxS[3] = new Table(0, 0, -1, null);
    NxS[4] = new Table(10, 1, -1, new short[] {199});
    NxS[5] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[6] = new Table(10, 83, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209});
    NxS[7] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 152, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 153, -1, 34});
    NxS[8] = new Table(33, 94, -1, new short[] {146, -1, 146, 146, -1, 146, 
        -1, -1, -1, 146, 146, -1, 146, 146, 146, 147, 147, 147, 147, 147, 147, 147, 
        147, 147, 147, 146, -1, 146, 146, 146, 146, 146, 148, 148, 148, 148, 148, 148, 
        148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 
        148, 148, 148, 148, -1, 146, -1, 146, 146, -1, 148, 148, 148, 148, 148, 148, 
        148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 
        148, 148, 148, 148, -1, 146, -1, 146});
    NxS[9] = new Table(0, 0, -1, null);
    NxS[10] = new Table(0, 0, -1, null);
    NxS[11] = new Table(64, 1, -1, new short[] {145});
    NxS[12] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 126, 126, 126, 126, 126, 126, 126, 
        126, 126, 126, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[13] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 111, 34, 112, 112, 112, 112, 112, 112, 112, 
        112, 112, 112, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 113, 114, 113, 
        36, 36, 36, 36, 36, 115, 113, 36, 36, 36, 36, 36, 36, 36, 116, 36, 
        36, 136, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 113, 114, 113, 
        36, 36, 36, 36, 36, 115, 113, 36, 36, 36, 36, 36, 36, 36, 116, 36, 
        36, 136, 36, 36, -1, 34, -1, 34});
    NxS[14] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 111, 34, 112, 112, 112, 112, 112, 112, 112, 
        112, 112, 112, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 113, 114, 113, 
        36, 36, 36, 36, 36, 115, 113, 36, 36, 36, 36, 36, 36, 36, 116, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 113, 114, 113, 
        36, 36, 36, 36, 36, 115, 113, 36, 36, 36, 36, 36, 36, 36, 116, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[15] = new Table(10, 1, 110, new short[] {-1});
    NxS[16] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[17] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[18] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[19] = new Table(0, 0, -1, null);
    NxS[20] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 108, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[21] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 102, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 103, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[22] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 94, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 95, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[23] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 85, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 91, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[24] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 80, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 81, 82, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[25] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 78, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 79, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[26] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 76, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[27] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 72, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[28] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 65, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 66, 36, 36, 36, 36, 36, 67, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[29] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 64, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[30] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 60, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[31] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 50, 36, 36, 36, 36, 36, 36, 51, 36, 36, 52, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[32] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 46, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[33] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 37, 38, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[34] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[35] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[36] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[37] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 41, 36, 
        36, 36, 42, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[38] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 39, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[39] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 40, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[40] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[41] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 45, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[42] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 43, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[43] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 44, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[44] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[45] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[46] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 47, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[47] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 48, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[48] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        49, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[49] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[50] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 56, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 57, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[51] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[52] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 53, 36, 
        36, 36, 54, 36, -1, 34, -1, 34});
    NxS[53] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 55, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[54] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[55] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[56] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[57] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 58, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[58] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        59, 36, 36, 36, -1, 34, -1, 34});
    NxS[59] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[60] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 61, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[61] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 62, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[62] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 63, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[63] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[64] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[65] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        71, 36, 36, 36, -1, 34, -1, 34});
    NxS[66] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 70, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[67] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 68, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[68] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 69, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[69] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[70] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[71] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[72] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 73, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[73] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 74, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[74] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 75, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[75] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[76] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 77, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[77] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[78] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[79] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[80] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 88, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[81] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[82] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 83, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[83] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 84, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[84] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 85, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[85] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 86, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[86] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 87, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[87] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[88] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 89, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[89] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 90, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[90] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[91] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 92, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[92] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 93, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[93] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[94] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 96, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[95] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[96] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 97, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[97] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 98, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[98] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 99, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[99] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 100, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[100] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 101, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[101] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[102] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 106, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[103] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 104, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[104] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 105, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[105] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[106] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 107, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[107] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[108] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 109, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[109] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[110] = new Table(10, 1, 110, new short[] {-1});
    NxS[111] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 126, 126, 126, 126, 126, 126, 126, 
        126, 126, 126, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[112] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 111, 34, 112, 112, 112, 112, 112, 112, 112, 
        112, 112, 112, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 113, 114, 113, 
        36, 36, 36, 36, 36, 115, 113, 36, 36, 36, 36, 36, 36, 36, 116, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 113, 114, 113, 
        36, 36, 36, 36, 36, 115, 113, 36, 36, 36, 36, 36, 36, 36, 116, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[113] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[114] = new Table(1, 126, -1, new short[] {206, 206, 206, 206, 206, 206, 
        206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 
        206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 119, 206, 119, 119, 206, 119, 
        206, 206, 206, 119, 119, -1, 34, 34, 34, 120, 120, 120, 120, 120, 120, 120, 
        120, 120, 120, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[115] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 118, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 118, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[116] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 117, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 117, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[117] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[118] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[119] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 120, 120, 120, 120, 120, 120, 120, 
        120, 120, 120, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[120] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 121, 121, 121, 121, 121, 121, 121, 
        121, 121, 121, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 122, 36, 122, 
        36, 36, 36, 36, 36, 36, 122, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 122, 36, 122, 
        36, 36, 36, 36, 36, 36, 122, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[121] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 121, 121, 121, 121, 121, 121, 121, 
        121, 121, 121, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 122, 36, 122, 
        36, 36, 36, 36, 36, 36, 122, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 122, 36, 122, 
        36, 36, 36, 36, 36, 36, 122, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[122] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[123] = new Table(48, 62, -1, new short[] {124, 124, 124, 124, 124, 124, 
        124, 124, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 125, -1, 
        125, -1, -1, -1, -1, -1, -1, 125, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 125, -1, 
        125, -1, -1, -1, -1, -1, -1, 125});
    NxS[124] = new Table(48, 62, -1, new short[] {124, 124, 124, 124, 124, 124, 
        124, 124, 124, 124, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 125, -1, 
        125, -1, -1, -1, -1, -1, -1, 125, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 125, -1, 
        125, -1, -1, -1, -1, -1, -1, 125});
    NxS[125] = new Table(0, 0, -1, null);
    NxS[126] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 127, 127, 127, 127, 127, 127, 127, 
        127, 127, 127, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 128, 129, 128, 
        36, 36, 36, 36, 36, 36, 128, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 128, 129, 128, 
        36, 36, 36, 36, 36, 36, 128, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[127] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 127, 127, 127, 127, 127, 127, 127, 
        127, 127, 127, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 128, 129, 128, 
        36, 36, 36, 36, 36, 36, 128, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 128, 129, 128, 
        36, 36, 36, 36, 36, 36, 128, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[128] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[129] = new Table(1, 126, -1, new short[] {207, 207, 207, 207, 207, 207, 
        207, 207, 207, 207, 207, 207, 207, 207, 207, 207, 207, 207, 207, 207, 207, 207, 
        207, 207, 207, 207, 207, 207, 207, 207, 207, 207, 130, 207, 130, 130, 207, 130, 
        207, 207, 207, 130, 130, -1, 34, 34, 34, 131, 131, 131, 131, 131, 131, 131, 
        131, 131, 131, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[130] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 131, 131, 131, 131, 131, 131, 131, 
        131, 131, 131, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[131] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 132, 132, 132, 132, 132, 132, 132, 
        132, 132, 132, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 128, 36, 128, 
        36, 36, 36, 36, 36, 36, 128, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 128, 36, 128, 
        36, 36, 36, 36, 36, 36, 128, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[132] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 132, 132, 132, 132, 132, 132, 132, 
        132, 132, 132, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 128, 36, 128, 
        36, 36, 36, 36, 36, 36, 128, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 128, 36, 128, 
        36, 36, 36, 36, 36, 36, 128, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[133] = new Table(48, 62, -1, new short[] {134, 134, 134, 134, 134, 134, 
        134, 134, 134, 134, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 135, -1, 
        135, -1, -1, -1, -1, -1, -1, 135, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 135, -1, 
        135, -1, -1, -1, -1, -1, -1, 135});
    NxS[134] = new Table(48, 62, -1, new short[] {134, 134, 134, 134, 134, 134, 
        134, 134, 134, 134, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 135, -1, 
        135, -1, -1, -1, -1, -1, -1, 135, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 135, -1, 
        135, -1, -1, -1, -1, -1, -1, 135});
    NxS[135] = new Table(0, 0, -1, null);
    NxS[136] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 137, 137, 137, 137, 137, 137, 137, 
        137, 137, 137, 34, -1, 34, 34, 34, 34, 34, 138, 138, 138, 138, 138, 138, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 138, 138, 138, 138, 138, 138, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[137] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 139, 139, 139, 139, 139, 139, 139, 
        139, 139, 139, 34, -1, 34, 34, 34, 34, 34, 140, 140, 140, 140, 140, 140, 
        36, 36, 36, 36, 36, 141, 36, 36, 36, 36, 36, 36, 36, 36, 142, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 140, 140, 140, 140, 140, 140, 
        36, 36, 36, 36, 36, 141, 36, 36, 36, 36, 36, 36, 36, 36, 142, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[138] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 139, 139, 139, 139, 139, 139, 139, 
        139, 139, 139, 34, -1, 34, 34, 34, 34, 34, 140, 140, 140, 140, 140, 140, 
        36, 36, 36, 36, 36, 141, 36, 36, 36, 36, 36, 36, 36, 36, 142, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 140, 140, 140, 140, 140, 140, 
        36, 36, 36, 36, 36, 141, 36, 36, 36, 36, 36, 36, 36, 36, 142, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[139] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 139, 139, 139, 139, 139, 139, 139, 
        139, 139, 139, 34, -1, 34, 34, 34, 34, 34, 140, 140, 140, 140, 140, 140, 
        36, 36, 36, 36, 36, 141, 36, 36, 36, 36, 36, 36, 36, 36, 142, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 140, 140, 140, 140, 140, 140, 
        36, 36, 36, 36, 36, 141, 36, 36, 36, 36, 36, 36, 36, 36, 142, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[140] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 139, 139, 139, 139, 139, 139, 139, 
        139, 139, 139, 34, -1, 34, 34, 34, 34, 34, 140, 140, 140, 140, 140, 140, 
        36, 36, 36, 36, 36, 141, 36, 36, 36, 36, 36, 36, 36, 36, 142, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 140, 140, 140, 140, 140, 140, 
        36, 36, 36, 36, 36, 141, 36, 36, 36, 36, 36, 36, 36, 36, 142, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[141] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 144, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 144, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[142] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 143, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 143, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[143] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[144] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[145] = new Table(0, 0, -1, null);
    NxS[146] = new Table(33, 94, -1, new short[] {149, -1, 149, 149, -1, 149, 
        -1, -1, -1, 149, 149, -1, 149, 149, 149, 150, 150, 150, 150, 150, 150, 150, 
        150, 150, 150, 149, -1, 149, 149, 149, 149, 149, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149, 149, -1, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149});
    NxS[147] = new Table(33, 94, -1, new short[] {149, -1, 149, 149, -1, 149, 
        -1, -1, -1, 149, 149, -1, 149, 149, 149, 150, 150, 150, 150, 150, 150, 150, 
        150, 150, 150, 149, -1, 149, 149, 149, 149, 149, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149, 149, -1, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149});
    NxS[148] = new Table(33, 94, -1, new short[] {149, -1, 149, 149, -1, 149, 
        -1, -1, -1, 149, 149, -1, 149, 149, 149, 150, 150, 150, 150, 150, 150, 150, 
        150, 150, 150, 149, -1, 149, 149, 149, 149, 149, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149, 149, -1, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149});
    NxS[149] = new Table(33, 94, -1, new short[] {149, -1, 149, 149, -1, 149, 
        -1, -1, -1, 149, 149, -1, 149, 149, 149, 150, 150, 150, 150, 150, 150, 150, 
        150, 150, 150, 149, -1, 149, 149, 149, 149, 149, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149, 149, -1, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149});
    NxS[150] = new Table(33, 94, -1, new short[] {149, -1, 149, 149, -1, 149, 
        -1, -1, -1, 149, 149, -1, 149, 149, 149, 150, 150, 150, 150, 150, 150, 150, 
        150, 150, 150, 149, -1, 149, 149, 149, 149, 149, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149, 149, -1, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149});
    NxS[151] = new Table(33, 94, -1, new short[] {149, -1, 149, 149, -1, 149, 
        -1, -1, -1, 149, 149, -1, 149, 149, 149, 150, 150, 150, 150, 150, 150, 150, 
        150, 150, 150, 149, -1, 149, 149, 149, 149, 149, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149, 149, -1, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 
        151, 151, 151, 151, -1, 149, -1, 149});
    NxS[152] = new Table(10, 117, 154, new short[] {-1, 154, 154, 154, 154, 154, 
        154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 
        154, 155, 154, 155, 155, 154, 155, -1, 154, 154, 155, 155, 154, 155, 155, 155, 
        156, 156, 156, 156, 156, 156, 156, 156, 156, 156, 155, 154, 155, 155, 155, 155, 
        155, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 
        157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 154, 158, 154, 155, 155, 
        154, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 
        157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 154, 155, 154, 155});
    NxS[153] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[154] = new Table(0, 0, -1, null);
    NxS[155] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[156] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[157] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[158] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        159, -1, -1, 34, 34, -1, 34, 34, 34, 160, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 161, 36, 
        36, 36, 36, 36, -1, 162, -1, 34, 34, -1, 163, 163, 36, 36, 36, 163, 
        36, 36, 36, 36, 36, 36, 36, 163, 36, 36, 36, 163, 36, 163, 164, 163, 
        36, 165, 36, 36, -1, 34, -1, 34});
    NxS[159] = new Table(0, 0, -1, null);
    NxS[160] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[161] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 182, 182, 182, 182, 182, 182, 182, 
        182, 182, 182, 34, -1, 34, 34, 34, 34, 34, 183, 183, 183, 183, 183, 183, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 183, 183, 183, 183, 183, 183, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[162] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[163] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[164] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 174, 174, 174, 174, 174, 174, 174, 
        174, 174, 174, 34, -1, 34, 34, 34, 34, 34, 175, 175, 175, 175, 175, 175, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 175, 175, 175, 175, 175, 175, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[165] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 166, 166, 166, 166, 166, 166, 166, 
        166, 166, 166, 34, -1, 34, 34, 34, 34, 34, 167, 167, 167, 167, 167, 167, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 167, 167, 167, 167, 167, 167, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[166] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 168, 168, 168, 168, 168, 168, 168, 
        168, 168, 168, 34, -1, 34, 34, 34, 34, 34, 169, 169, 169, 169, 169, 169, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 169, 169, 169, 169, 169, 169, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[167] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 168, 168, 168, 168, 168, 168, 168, 
        168, 168, 168, 34, -1, 34, 34, 34, 34, 34, 169, 169, 169, 169, 169, 169, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 169, 169, 169, 169, 169, 169, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[168] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 170, 170, 170, 170, 170, 170, 170, 
        170, 170, 170, 34, -1, 34, 34, 34, 34, 34, 171, 171, 171, 171, 171, 171, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 171, 171, 171, 171, 171, 171, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[169] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 170, 170, 170, 170, 170, 170, 170, 
        170, 170, 170, 34, -1, 34, 34, 34, 34, 34, 171, 171, 171, 171, 171, 171, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 171, 171, 171, 171, 171, 171, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[170] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 172, 172, 172, 172, 172, 172, 172, 
        172, 172, 172, 34, -1, 34, 34, 34, 34, 34, 173, 173, 173, 173, 173, 173, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 173, 173, 173, 173, 173, 173, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[171] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 172, 172, 172, 172, 172, 172, 172, 
        172, 172, 172, 34, -1, 34, 34, 34, 34, 34, 173, 173, 173, 173, 173, 173, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 173, 173, 173, 173, 173, 173, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[172] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[173] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[174] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 176, 176, 176, 176, 176, 176, 176, 
        176, 176, 176, 34, -1, 34, 34, 34, 34, 34, 177, 177, 177, 177, 177, 177, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 177, 177, 177, 177, 177, 177, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[175] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 176, 176, 176, 176, 176, 176, 176, 
        176, 176, 176, 34, -1, 34, 34, 34, 34, 34, 177, 177, 177, 177, 177, 177, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 177, 177, 177, 177, 177, 177, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[176] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 178, 178, 178, 178, 178, 178, 178, 
        178, 178, 178, 34, -1, 34, 34, 34, 34, 34, 179, 179, 179, 179, 179, 179, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 179, 179, 179, 179, 179, 179, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[177] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 178, 178, 178, 178, 178, 178, 178, 
        178, 178, 178, 34, -1, 34, 34, 34, 34, 34, 179, 179, 179, 179, 179, 179, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 179, 179, 179, 179, 179, 179, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[178] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 180, 180, 180, 180, 180, 180, 180, 
        180, 180, 180, 34, -1, 34, 34, 34, 34, 34, 181, 181, 181, 181, 181, 181, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 181, 181, 181, 181, 181, 181, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[179] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 180, 180, 180, 180, 180, 180, 180, 
        180, 180, 180, 34, -1, 34, 34, 34, 34, 34, 181, 181, 181, 181, 181, 181, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 181, 181, 181, 181, 181, 181, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[180] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[181] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[182] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 184, 184, 184, 184, 184, 184, 184, 
        184, 184, 184, 34, -1, 34, 34, 34, 34, 34, 185, 185, 185, 185, 185, 185, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 185, 185, 185, 185, 185, 185, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[183] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 184, 184, 184, 184, 184, 184, 184, 
        184, 184, 184, 34, -1, 34, 34, 34, 34, 34, 185, 185, 185, 185, 185, 185, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 185, 185, 185, 185, 185, 185, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[184] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 186, 186, 186, 186, 186, 186, 186, 
        186, 186, 186, 34, -1, 34, 34, 34, 34, 34, 187, 187, 187, 187, 187, 187, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 187, 187, 187, 187, 187, 187, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[185] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 186, 186, 186, 186, 186, 186, 186, 
        186, 186, 186, 34, -1, 34, 34, 34, 34, 34, 187, 187, 187, 187, 187, 187, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 187, 187, 187, 187, 187, 187, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[186] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 188, 188, 188, 188, 188, 188, 188, 
        188, 188, 188, 34, -1, 34, 34, 34, 34, 34, 189, 189, 189, 189, 189, 189, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 189, 189, 189, 189, 189, 189, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[187] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 188, 188, 188, 188, 188, 188, 188, 
        188, 188, 188, 34, -1, 34, 34, 34, 34, 34, 189, 189, 189, 189, 189, 189, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 189, 189, 189, 189, 189, 189, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[188] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 190, 190, 190, 190, 190, 190, 190, 
        190, 190, 190, 34, -1, 34, 34, 34, 34, 34, 191, 191, 191, 191, 191, 191, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 191, 191, 191, 191, 191, 191, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[189] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 190, 190, 190, 190, 190, 190, 190, 
        190, 190, 190, 34, -1, 34, 34, 34, 34, 34, 191, 191, 191, 191, 191, 191, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 191, 191, 191, 191, 191, 191, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[190] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 192, 192, 192, 192, 192, 192, 192, 
        192, 192, 192, 34, -1, 34, 34, 34, 34, 34, 193, 193, 193, 193, 193, 193, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 193, 193, 193, 193, 193, 193, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[191] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 192, 192, 192, 192, 192, 192, 192, 
        192, 192, 192, 34, -1, 34, 34, 34, 34, 34, 193, 193, 193, 193, 193, 193, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 193, 193, 193, 193, 193, 193, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[192] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 194, 194, 194, 194, 194, 194, 194, 
        194, 194, 194, 34, -1, 34, 34, 34, 34, 34, 195, 195, 195, 195, 195, 195, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 195, 195, 195, 195, 195, 195, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[193] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 194, 194, 194, 194, 194, 194, 194, 
        194, 194, 194, 34, -1, 34, 34, 34, 34, 34, 195, 195, 195, 195, 195, 195, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 195, 195, 195, 195, 195, 195, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[194] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 196, 196, 196, 196, 196, 196, 196, 
        196, 196, 196, 34, -1, 34, 34, 34, 34, 34, 197, 197, 197, 197, 197, 197, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 197, 197, 197, 197, 197, 197, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[195] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 196, 196, 196, 196, 196, 196, 196, 
        196, 196, 196, 34, -1, 34, 34, 34, 34, 34, 197, 197, 197, 197, 197, 197, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 197, 197, 197, 197, 197, 197, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[196] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[197] = new Table(33, 94, -1, new short[] {34, -1, 34, 34, -1, 34, 
        -1, -1, -1, 34, 34, -1, 34, 34, 34, 35, 35, 35, 35, 35, 35, 35, 
        35, 35, 35, 34, -1, 34, 34, 34, 34, 34, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34, 34, -1, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 36, 
        36, 36, 36, 36, -1, 34, -1, 34});
    NxS[198] = new Table(0, 0, -1, null);
    NxS[199] = new Table(0, 0, -1, null);
    NxS[200] = new Table(9, 24, -1, new short[] {200, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, 200});
    NxS[201] = new Table(10, 115, 204, new short[] {-1, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, -1});
    NxS[202] = new Table(35, 1, -1, new short[] {203});
    NxS[203] = new Table(0, 0, -1, null);
    NxS[204] = new Table(10, 115, 204, new short[] {-1, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 
        204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, -1});
    NxS[205] = new Table(9, 118, 1, new short[] {2, 3, 1, 1, 4, 1, 
        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
        1, 2, 5, 6, 7, 5, 1, 5, 8, 9, 10, 5, 5, 11, 5, 12, 
        5, 13, 14, 14, 14, 14, 14, 14, 14, 14, 14, 5, 15, 5, 16, 5, 
        17, 5, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 
        18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 1, 5, 1, 5, 
        5, 19, 20, 18, 21, 22, 23, 24, 18, 18, 25, 18, 18, 26, 27, 28, 
        29, 18, 30, 18, 18, 31, 32, 18, 33, 18, 18, 18, 1, 5, 1, 5});
    NxS[206] = new Table(48, 10, -1, new short[] {123, 123, 123, 123, 123, 123, 
        123, 123, 123, 123});
    NxS[207] = new Table(48, 10, -1, new short[] {133, 133, 133, 133, 133, 133, 
        133, 133, 133, 133});
    NxS[208] = new Table(10, 83, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209});
    NxS[209] = new Table(34, 87, -1, new short[] {210, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 211, -1, -1, 
        -1, -1, -1, -1, 210, -1, -1, -1, -1, 210, 210, -1, -1, -1, 210, -1, 
        -1, -1, -1, -1, -1, -1, 210, -1, -1, -1, 210, -1, 210, 212, 210, -1, 
        213});
    NxS[210] = new Table(10, 83, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209});
    NxS[211] = new Table(48, 55, -1, new short[] {222, 222, 222, 222, 222, 222, 
        222, 222, 222, 222, -1, -1, -1, -1, -1, -1, -1, 222, 222, 222, 222, 222, 
        222, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 222, 222, 222, 222, 222, 
        222});
    NxS[212] = new Table(48, 55, -1, new short[] {218, 218, 218, 218, 218, 218, 
        218, 218, 218, 218, -1, -1, -1, -1, -1, -1, -1, 218, 218, 218, 218, 218, 
        218, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 218, 218, 218, 218, 218, 
        218});
    NxS[213] = new Table(48, 55, -1, new short[] {214, 214, 214, 214, 214, 214, 
        214, 214, 214, 214, -1, -1, -1, -1, -1, -1, -1, 214, 214, 214, 214, 214, 
        214, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 214, 214, 214, 214, 214, 
        214});
    NxS[214] = new Table(10, 93, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        215, 215, 215, 215, 215, 215, 215, 215, 215, 215, 208, 208, 208, 208, 208, 208, 
        208, 215, 215, 215, 215, 215, 215, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209, 208, 208, 208, 
        208, 215, 215, 215, 215, 215, 215});
    NxS[215] = new Table(10, 93, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 208, 208, 208, 208, 208, 208, 
        208, 216, 216, 216, 216, 216, 216, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209, 208, 208, 208, 
        208, 216, 216, 216, 216, 216, 216});
    NxS[216] = new Table(10, 93, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 208, 208, 208, 208, 208, 208, 
        208, 217, 217, 217, 217, 217, 217, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209, 208, 208, 208, 
        208, 217, 217, 217, 217, 217, 217});
    NxS[217] = new Table(10, 83, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209});
    NxS[218] = new Table(48, 55, -1, new short[] {219, 219, 219, 219, 219, 219, 
        219, 219, 219, 219, -1, -1, -1, -1, -1, -1, -1, 219, 219, 219, 219, 219, 
        219, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 219, 219, 219, 219, 219, 
        219});
    NxS[219] = new Table(48, 55, -1, new short[] {220, 220, 220, 220, 220, 220, 
        220, 220, 220, 220, -1, -1, -1, -1, -1, -1, -1, 220, 220, 220, 220, 220, 
        220, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 220, 220, 220, 220, 220, 
        220});
    NxS[220] = new Table(48, 55, -1, new short[] {221, 221, 221, 221, 221, 221, 
        221, 221, 221, 221, -1, -1, -1, -1, -1, -1, -1, 221, 221, 221, 221, 221, 
        221, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 221, 221, 221, 221, 221, 
        221});
    NxS[221] = new Table(10, 83, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209});
    NxS[222] = new Table(48, 55, -1, new short[] {223, 223, 223, 223, 223, 223, 
        223, 223, 223, 223, -1, -1, -1, -1, -1, -1, -1, 223, 223, 223, 223, 223, 
        223, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 223, 223, 223, 223, 223, 
        223});
    NxS[223] = new Table(48, 55, -1, new short[] {224, 224, 224, 224, 224, 224, 
        224, 224, 224, 224, -1, -1, -1, -1, -1, -1, -1, 224, 224, 224, 224, 224, 
        224, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 224, 224, 224, 224, 224, 
        224});
    NxS[224] = new Table(48, 55, -1, new short[] {225, 225, 225, 225, 225, 225, 
        225, 225, 225, 225, -1, -1, -1, -1, -1, -1, -1, 225, 225, 225, 225, 225, 
        225, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 225, 225, 225, 225, 225, 
        225});
    NxS[225] = new Table(48, 55, -1, new short[] {226, 226, 226, 226, 226, 226, 
        226, 226, 226, 226, -1, -1, -1, -1, -1, -1, -1, 226, 226, 226, 226, 226, 
        226, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 226, 226, 226, 226, 226, 
        226});
    NxS[226] = new Table(48, 55, -1, new short[] {227, 227, 227, 227, 227, 227, 
        227, 227, 227, 227, -1, -1, -1, -1, -1, -1, -1, 227, 227, 227, 227, 227, 
        227, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 227, 227, 227, 227, 227, 
        227});
    NxS[227] = new Table(48, 55, -1, new short[] {228, 228, 228, 228, 228, 228, 
        228, 228, 228, 228, -1, -1, -1, -1, -1, -1, -1, 228, 228, 228, 228, 228, 
        228, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 228, 228, 228, 228, 228, 
        228});
    NxS[228] = new Table(48, 55, -1, new short[] {229, 229, 229, 229, 229, 229, 
        229, 229, 229, 229, -1, -1, -1, -1, -1, -1, -1, 229, 229, 229, 229, 229, 
        229, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
        -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 229, 229, 229, 229, 229, 
        229});
    NxS[229] = new Table(10, 83, 208, new short[] {-1, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 198, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 
        208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 208, 209});
    NxS[230] = new Table(10, 115, 201, new short[] {-1, 201, 201, 201, 201, 201, 
        201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 
        201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 
        201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 
        201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 
        201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 
        201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 
        201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 202});
    }

int NextState(int qStat) {
    if (chr == ScanBuff.EOF)
        return (qStat <= maxAccept && qStat != currentStart ? currentStart : eofNum);
    else {
        int rslt;
        uint idx = (byte)(chr - NxS[qStat].min);
        if (idx >= (uint)NxS[qStat].rng) rslt = NxS[qStat].dflt;
        else rslt = NxS[qStat].nxt[idx];
        return (rslt == goStart ? currentStart : rslt);
    }
}

int NextState() {
    if (chr == ScanBuff.EOF)
        return (state <= maxAccept && state != currentStart ? currentStart : eofNum);
    else {
        int rslt;
        uint idx = (byte)(chr - NxS[state].min);
        if (idx >= (uint)NxS[state].rng) rslt = NxS[state].dflt;
        else rslt = NxS[state].nxt[idx];
        return (rslt == goStart ? currentStart : rslt);
    }
}
#endregion


#if BACKUP
        // ====================== Nested class ==========================

        internal class Context // class used for automaton backup.
        {
            public int bPos;
            public int cPos;
            public int state;
            public int cChr;
        }
#endif // BACKUP


        // ====================== Nested class ==========================

        public sealed class StringBuff : ScanBuff
        {
            string str;        // input buffer
            int bPos;          // current position in buffer
            int sLen;

            public StringBuff(string str)
            {
                this.str = str;
                this.sLen = str.Length;
            }

            public override int Read()
            {
                if (bPos < sLen) return str[bPos++];
#if BABEL
                else if (bPos == sLen) { bPos++; return '\n'; }   // one strike, see newline
#endif // BABEL
                else return EOF;                                  // two strikes and you're out!
            }

            public override int Peek()
            {
                if (bPos < sLen) return str[bPos];
                else return '\n';
            }

            public override string GetString(int beg, int end)
            {
                //  "end" can be greater than sLen with the BABEL
                //  option set.  Read returns a "virtual" EOL if
                //  an attempt is made to read past the end of the
                //  string buffer.  Without the guard any attempt 
                //  to fetch yytext for a token that includes the 
                //  EOL will throw an index exception.
                if (end > sLen) end = sLen;
                if (end <= beg) return ""; 
                else return str.Substring(beg, end - beg);
            }

            public override int Pos
            {
                get { return bPos; }
                set { bPos = value; }
            }
        }

        // ====================== Nested class ==========================

        public sealed class StreamBuff : ScanBuff
        {
            BufferedStream bStrm;   // input buffer

            public StreamBuff(Stream str) { this.bStrm = new BufferedStream(str); }

            public override int Read()
            {
                int byt = bStrm.ReadByte();
                if (byt == -1) return EOF;
                else return byt;
            }

            public override int Peek()
            {
                int rslt = Read();
                bStrm.Seek(-1, SeekOrigin.Current);
                return rslt;
            }

            public override string GetString(int beg, int end)
            {
                if (end - beg <= 0) return "";
                long savePos = bStrm.Position;
                char[] arr = new char[end - beg];
                bStrm.Position = (long)beg;
                for (int i = 0; i < (end - beg); i++)
                    arr[i] = (char)Read();
                bStrm.Position = savePos;
                return new String(arr);
            }

            public override int Pos
            {
                get { return (int)bStrm.Position; }
                set { bStrm.Position = value; }
            }
        }

        // =================== End Nested classes =======================

        public Scanner(Stream file) {
            buffer = new StreamBuff(file);
            this.cPos = -1;
            this.chr = '\n'; // to initialize yyline, yycol and lineStart
            GetChr();
        }

        public Scanner() { }

        void GetChr()
        {
            if (chr == '\n') { lineStart = buffer.Pos; lNum++; }
            chr = buffer.Read(); cPos++;
        }

        void MarkToken()
        {
            tokPos = cPos;
            tokLin = lNum;
            tokCol = cPos - lineStart;
        }
        
        void MarkEnd()
        {
            tokTxt = null;
            tokEPos = cPos;
            tokELin = lNum;
            tokECol = cPos - lineStart;

        }

        // ================ StringBuffer Initialization ===================

        public void SetSource(string source, int offset)
        {
            this.buffer = new StringBuff(source);
            this.buffer.Pos = offset;
            this.cPos = offset - 1;
            this.chr = '\n'; // to initialize yyline, yycol and lineStart
            GetChr();
        }
        
#if BABEL
        //
        //  Get the next token for Visual Studio
        //
        //  "state" is the inout mode variable that maintains scanner
        //  state between calls, using the EolState property. In principle,
        //  if the calls of EolState are costly set could be called once
        //  only per line, at the start; and get called only at the end
        //  of the line. This needs more infrastructure ...
        public int GetNext(ref int state, out int start, out int end)
        {
            Tokens next;
            int s, e;
            s = state;        // state at start
            EolState = state;
            next = (Tokens)Scan();
            state = EolState;
            e = state;       // state at end;
            start = tokPos;
            end = tokEPos - 1; // end is the index of last char.
            // if (next > Tokens.maxParseToken)
            //     Trace.WriteLine(String.Format("({0}-{1}) {2}->{3} {4}", start, end, s, e, next.ToString()));
            return (int)next;
        }        
#endif // BABEL

        // ======== IScanner<> Implementation =========

        public override int yylex()
        {
            // parserMax is set by reflecting on the Tokens
            // enumeration.  If maxParseTokeen is defined
            // that is used, otherwise int.MaxValue is used.
            int next;
            do { next = Scan(); } while (next >= parserMax);
            return next;
        }
        
        int yyleng { get { return tokEPos - tokPos; } }
        int yypos { get { return tokPos; } }
        int yyline { get { return tokLin; } }
        int yycol { get { return tokCol; } }

        public string yytext
        {
            get 
            {
                if (tokTxt == null) 
                    tokTxt = buffer.GetString(tokPos, tokEPos);
                return tokTxt;
            }
        }

        void yyless(int n) { 
            int pos = tokPos + n;
            buffer.Pos = pos;
            cPos = pos - 1; 
            GetChr(); 
            MarkEnd(); 
        }

        // ============ methods available in actions ==============

        internal int YY_START {
            get { return currentScOrd; }
            set { currentScOrd = value; } 
        }
        
        internal void BEGIN(int next) {
            currentScOrd = next;
            currentStart = startState[next];
        }

        // ============== The main tokenizer code =================

        int Scan()
        {
// local variables
                for (; ; )
                {
                    int next;              // next state to enter                   
#if BACKUP
                    bool inAccept = false; // inAccept ==> current state is an accept state
                    Result rslt = Result.noMatch;
                    // skip "idle" states
#if LEFTANCHORS
                    if (lineStart == cPos &&
                        NextState(anchorState[currentScOrd]) != currentStart)
                        state = anchorState[currentScOrd];
                    else {
                        state = currentStart;
                        while (NextState() == currentStart) {
                            GetChr();
                            if (lineStart == cPos &&
                                NextState(anchorState[currentScOrd]) != currentStart) {
                                state = anchorState[currentScOrd];
                                break;
                            }
                        }
                    }
#else // !LEFTANCHORS
                    state = currentStart;
                    while (NextState() == state) 
                        GetChr(); // skip "idle" transitions
#endif // LEFTANCHORS
                    MarkToken();
                    
                    while ((next = NextState()) != currentStart)
                        if (inAccept && next > maxAccept) // need to prepare backup data
                        {
                            Context ctx = new Context();
                            rslt = Recurse2(ctx, next);
                            if (rslt == Result.noMatch) RestoreStateAndPos(ctx);
                            // else if (rslt == Result.contextFound) RestorePos(ctx);
                            break;
                        }
                        else
                        {
                            state = next;
                            GetChr();
                            if (state <= maxAccept) inAccept = true;
                        }
#else // !BACKUP
#if LEFTANCHORS
                    if (lineStart == cPos &&
                        NextState(anchorState[currentScOrd]) != currentStart)
                        state = anchorState[currentScOrd];
                    else {
                        state = currentStart;
                        while (NextState() == currentStart) {
                            GetChr();
                            if (lineStart == cPos &&
                                NextState(anchorState[currentScOrd]) != currentStart) {
                                state = anchorState[currentScOrd];
                                break;
                            }
                        }
                    }
#else // !LEFTANCHORS
                    state = currentStart;
                    while (NextState() == state) 
                        GetChr(); // skip "idle" transitions
#endif // LEFTANCHORS
                    MarkToken();
                    // common code
                    while ((next = NextState()) != currentStart)
                    {
                        state = next;
                        GetChr();
                    }
#endif // BACKUP
                    if (state > maxAccept) 
                    {
                        state = currentStart;
                    }
                    else
                    {
                        MarkEnd();
#pragma warning disable 162												
#region ActionSwitch
    switch (state)
    {
        case eofNum:
            switch (currentStart) {
                case 205:
{ }
                    break;
            }
            return (int)Tokens.EOF;
        case 1:
        case 4:
        case 6:
Console.Error.WriteLine("Bad input: '{0}'", yytext);
            break;
        case 2:
        case 200:
;
            break;
        case 3:
        case 199:
;
            break;
        case 5:
        case 7:
        case 12:
        case 18:
        case 20:
        case 21:
        case 22:
        case 23:
        case 24:
        case 25:
        case 26:
        case 27:
        case 28:
        case 29:
        case 30:
        case 31:
        case 32:
        case 33:
        case 34:
        case 35:
        case 36:
        case 37:
        case 38:
        case 39:
        case 41:
        case 42:
        case 43:
        case 46:
        case 47:
        case 48:
        case 50:
        case 52:
        case 53:
        case 57:
        case 58:
        case 60:
        case 61:
        case 62:
        case 65:
        case 66:
        case 67:
        case 68:
        case 72:
        case 73:
        case 74:
        case 76:
        case 80:
        case 82:
        case 84:
        case 85:
        case 86:
        case 88:
        case 89:
        case 91:
        case 92:
        case 94:
        case 96:
        case 97:
        case 98:
        case 99:
        case 100:
        case 102:
        case 103:
        case 104:
        case 106:
        case 108:
        case 111:
        case 114:
        case 119:
        case 129:
        case 130:
        case 136:
        case 152:
        case 158:
        case 161:
        case 164:
        case 165:
        case 174:
        case 175:
        case 176:
        case 177:
        case 178:
        case 179:
        case 182:
        case 183:
        case 184:
        case 185:
        case 186:
        case 187:
        case 188:
        case 189:
        case 190:
        case 191:
        case 192:
        case 193:
        case 194:
        case 195:
return Make(Tokens.IDENTIFIER);
            break;
        case 8:
return Make(Tokens.QUOTE);
            break;
        case 9:
return Make(Tokens.LBRACE);
            break;
        case 10:
return Make(Tokens.RBRACE);
            break;
        case 11:
return Make(Tokens.UNQUOTE);
            break;
        case 13:
        case 14:
        case 112:
        case 115:
        case 116:
        case 117:
        case 118:
        case 137:
        case 138:
        case 139:
        case 140:
        case 141:
        case 142:
        case 143:
        case 144:
return Make(Tokens.INTEGER);
            break;
        case 15:
        case 110:
{  }
            break;
        case 16:
return Make(Tokens.ASSIGN);
            break;
        case 17:
return (int)yytext[0];
            break;
        case 19:
return Make(Tokens.BACKQUOTE);
            break;
        case 40:
return Make(Tokens.WITH);
            break;
        case 44:
return Make(Tokens.WHILE);
            break;
        case 45:
return Make(Tokens.WHEN);
            break;
        case 49:
return Make(Tokens.USING);
            break;
        case 51:
return Make(Tokens.TO);
            break;
        case 54:
return Make(Tokens.TRY);
            break;
        case 55:
        case 69:
        case 90:
return Make(Tokens.LITERAL);
            break;
        case 56:
return Make(Tokens.THE);
            break;
        case 59:
return Make(Tokens.THROW);
            break;
        case 63:
return Make(Tokens.SQUOTE);
            break;
        case 64:
return Make(Tokens.OR);
            break;
        case 70:
return Make(Tokens.NOT);
            break;
        case 71:
return Make(Tokens.NEW);
            break;
        case 75:
return Make(Tokens.MACRO);
            break;
        case 77:
return Make(Tokens.LET);
            break;
        case 78:
return Make(Tokens.IF);
            break;
        case 79:
return Make(Tokens.IS);
            break;
        case 81:
return Make(Tokens.FN);
            break;
        case 83:
return Make(Tokens.FOR);
            break;
        case 87:
return Make(Tokens.EACH);
            break;
        case 93:
return Make(Tokens.ELSE);
            break;
        case 95:
return Make(Tokens.DO);
            break;
        case 101:
return Make(Tokens.DEFCLASS);
            break;
        case 105:
return Make(Tokens.COND);
            break;
        case 107:
return Make(Tokens.CALL);
            break;
        case 109:
return Make(Tokens.AND);
            break;
        case 113:
        case 120:
        case 121:
        case 122:
        case 123:
        case 124:
        case 125:
        case 126:
        case 127:
        case 128:
        case 131:
        case 132:
        case 133:
        case 134:
        case 135:
return Make(Tokens.REAL);
            break;
        case 145:
return Make(Tokens.SPLICE);
            break;
        case 146:
        case 147:
        case 148:
        case 149:
        case 150:
        case 151:
return Make(Tokens.QUOTEIDENTIFIER);
            break;
        case 153:
yy_push_state(ML_COMMENT);
            break;
        case 154:
        case 155:
        case 156:
        case 157:
        case 159:
        case 160:
        case 162:
        case 163:
        case 166:
        case 167:
        case 168:
        case 169:
        case 170:
        case 171:
        case 172:
        case 173:
        case 180:
        case 181:
        case 196:
        case 197:
return Make(Tokens.CHARACTER);
            break;
        case 198:
return Make(Tokens.STRING);
            break;
        case 201:
        case 204:
;
            break;
        case 202:
;
            break;
        case 203:
yy_pop_state();
            break;
        default:
            break;
    }
#endregion
#pragma warning restore 162
                    }
                }
        }

#if BACKUP
        Result Recurse2(Context ctx, int next)
        {
            // Assert: at entry "state" is an accept state AND
            //         NextState(state, chr) != currentStart AND
            //         NextState(state, chr) is not an accept state.
            //
            bool inAccept;
            SaveStateAndPos(ctx);
            state = next;
            if (state == eofNum) return Result.accept;
            GetChr();
            inAccept = false;

            while ((next = NextState()) != currentStart)
            {
                if (inAccept && next > maxAccept) // need to prepare backup data
                    SaveStateAndPos(ctx);
                state = next;
                if (state == eofNum) return Result.accept;
                GetChr(); 
                inAccept = (state <= maxAccept);
            }
            if (inAccept) return Result.accept; else return Result.noMatch;
        }

        void SaveStateAndPos(Context ctx)
        {
            ctx.bPos  = buffer.Pos;
            ctx.cPos  = cPos;
            ctx.state = state;
            ctx.cChr = chr;
        }

        void RestoreStateAndPos(Context ctx)
        {
            buffer.Pos = ctx.bPos;
            cPos = ctx.cPos;
            state = ctx.state;
            chr = ctx.cChr;
        }

        void RestorePos(Context ctx) { buffer.Pos = ctx.bPos; cPos = ctx.cPos; }
#endif // BACKUP

        // ============= End of the tokenizer code ================

#if STACK        
        internal void yy_clear_stack() { scStack.Clear(); }
        internal int yy_top_state() { return scStack.Peek(); }
        
        internal void yy_push_state(int state)
        {
            scStack.Push(currentScOrd);
            BEGIN(state);
        }
        
        internal void yy_pop_state()
        {
            // Protect against input errors that pop too far ...
            if (scStack.Count > 0) {
				int newSc = scStack.Pop();
				BEGIN(newSc);
            } // Otherwise leave stack unchanged.
        }
 #endif // STACK

        internal void ECHO() { Console.Out.Write(yytext); }
        
    } // end class Scanner
} // end namespace
